﻿<%@ page language="C#" autoeventwireup="true" inherits="Widget, CardioLog_deploy" validaterequest="false" %>

<html>
<head>
    <title></title>
    <link rel="stylesheet" type="text/css" media="screen,projection" href="/CardioLog/MarketingSuite/Assets/Styles/style.css" />
    <link rel="stylesheet" type="text/css" media="screen,projection" href="/CardioLog/MarketingSuite/SEO/Assets/css/style.css" />
    <link rel="stylesheet" type="text/css" media="screen,projection" href="/CardioLog/2010/Controls/css/style.css" />
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/common.js"></script>
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/jquery-1.4.4.min.js"></script>
    <script type="text/javascript" src="/CardioLog/Scripts/jquery.json-2.2.js"></script>
    <script type="text/javascript" src="/CardioLogScripts/PopupManager.js"></script>
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/jquery.wresize.js"></script>
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/scripts.js"></script>
    <style type="text/css">
        .formbox
        {
            width: 99.5%;
        }
        
        .refreshloader
        {
            text-align: center;
            background: transparent url("../../Images/loading_box_232x186.png") no-repeat 0 0;
            width: 232px;
            height: 186px;
            z-index: 9999;
        }
        
        .refreshloader IMG
        {
            margin: 61px 0 0 0;
        }
    </style>
    <script type="text/javascript">
        var model;

        function onBrowse() {
            var myJSONObject =
			    { "popupArguments": [
                    {
                        "title": "Select Report Path",
                        "self": document,
                        "data": {
                            "locationOrder": model.Location.Order,              //$("#hdnLocationOrder").val(),
                            "locationCategory": model.Location.Category,        //$("#hdnLocationCategory").val(),
                            "locationID": model.Location.DirectoryId,           //$("#hdnLocation").val(),
                            "locationPath": model.Location.DirectoryPath        //$("#locationPath").val()
                        },
                        "callback": function (res) {
                            model.Location.Category = res["locationCategory"];
                            model.Location.DirectoryId = res["locationID"]; //$("#hdnLocation").val(res["locationID"]);
                            model.Location.Order = res["locationOrder"];
                            model.Location.DirectoryPath = res["locationPath"];

                            $("#locationPath").val(model.Location.DirectoryPath);

                            if (!model.Exists && $("#ctrlName").val()) {
                                $("#txtProc").val(buildProcedureName());
                            }
                        }
                    }]
			    };

                var url = '/Cardiolog/Designer/MenuLocationSelector.aspx';

                parent.PopupManager.ShowPopup(url, 320, 400, myJSONObject, 420, 600);
        }

        function getPrefs(controlType) {
            var prefs;
            switch (controlType) {
                case "MenuEntry":
                    break;

                case "Meter":
                    prefs = '<prefs><showhelp>false</showhelp><showpreferences>false</showpreferences><timeframe>36000000000</timeframe><timeinterval>36000000000</timeinterval><minvalue>0</minvalue><maxvalue>100</maxvalue><undershoot>0</undershoot><overshoot>100</overshoot><ctitle>_INTERNAL_REPORT_NAME</ctitle><chartType>static</chartType><adgroup></adgroup><adgroupname></adgroupname><categories></categories></prefs>'
                    break;

                case "Chart":
                    prefs = '<prefs><enable3D>false</enable3D><a_GRADIENT>TopBottom</a_GRADIENT><a_SECCOLOR>White</a_SECCOLOR><s_GRADIENT>None</s_GRADIENT><perspective>false</perspective><legend>false</legend><l_INSIDECHART>false</l_INSIDECHART><l_STYLE>row</l_STYLE><l_DOCKING>top</l_DOCKING><labels>false</labels><showtitle>false</showtitle><showhelp>false</showhelp><showpreferences>false</showpreferences><timeframe>36000000000</timeframe><timeinterval>36000000000</timeinterval><rules></rules><ctitle>_INTERNAL_REPORT_NAME</ctitle><type>Column</type><palette>CardioLog</palette><adgroup></adgroup><adgroupname></adgroupname><categories></categories></prefs>'
                    break;

                case "Table":
                default:
                    //<column id="Title" title="$Title$" type="SPPage" width="60%" /><column id="url" title="Url" width="0" type="hidden" /><column id="NumberOfLikes" title="Number Of Likes" width="40%" type="number" />
                    prefs = '<prefs><showhelp>false</showhelp><showpreferences>false</showpreferences><timeframe>36000000000</timeframe><timeinterval>36000000000</timeinterval><maxrows>100</maxrows><mincount>1</mincount><reporttype>' + model.ReportTypeID + '</reporttype><columns></columns><ctitle>_INTERNAL_REPORT_NAME</ctitle><chartType>static</chartType><adgroup></adgroup><adgroupname></adgroupname><categories></categories></prefs>';
                    break;
            }

//            if (model.Name) {
//                prefs = prefs.replace("_INTERNAL_REPORT_NAME", model.Name);
//            }

            return prefs;
        }


        function onControlTypeChanged() {
            var ctrlType = $("#ctrlType").val();
            if (ctrlType == "MenuEntry" ) {
                //$("#rowPrefs").hide();
                $("#rowDescription").hide();
                $("#divDataBinding").hide();
                $("#widjetPropertiesSection").hide();

                return;
            }

            if (ctrlType == "Meter") {
                $("#widjetPropertiesSection").hide();
                $("#divDataBinding").hide();
            }

            //$("#rowPrefs").show();
            $("#rowDescription").show();
            $("#divDataBinding").show();

            $("#control-prefs").val(getPrefs(ctrlType));

            if (ctrlType == "Table") {
                clearReportColumns();

                $("#reportColumnsDiv").show();
                $("#chartRulesDiv").hide();
            }
            else if (ctrlType == "Chart") {
                clearRules();

                $("#reportColumnsDiv").hide();
                $("#chartRulesDiv").show();
            }
            else {
                $("#reportColumnsDiv").hide();
                $("#chartRulesDiv").hide();
            }

            if (!model.Exists && $("#ctrlName").val()) {
                $("#txtProc").val(buildProcedureName());
            }
        }

        $(function () {
            $("#ctrlType").change(function () {
                onControlTypeChanged();
            });

            $("#ctrlName").change(function () {
                if (!model.Exists &&  $("#ctrlName").val()) {
                    $("#txtProc").val(buildProcedureName());
                }
                else {
                    $("#txtProc").val();
                }
            });
        });

        function clearReportColumns() {
            jQuery.each($('#reportColumnsTable > tbody > tr > td'), function () {
                var tr = $(this).parent('tr');

                if (tr.attr("id") != "floating-row") {
                    tr.remove();
                }
            });

            onAddReportColumn();
        }

        function clearRules() {
            jQuery.each($('#chartRulesTable > tbody > tr > td'), function () {
                var tr = $(this).parent('tr');

                if (tr.attr("id") != "rules-floating-row") {
                    tr.remove();
                }
            });

            onAddRule();
        }

        function onRuleFieldChanged() {
            clearRules();
        }


        function onAddRule() {
            $("#chartRulesTable > tbody > tr:last").before(getDefaultChartRuleHtml());
        }

        function onAddReportColumn() {
            $("#reportColumnsTable > tbody > tr:last").before(getDefaultReportColumnHtml());
        }

        function onRemoveReportColumn(rowid) {
            $("#" + rowid).remove();
        }

        function onRemoveChartRule(rowid) {
            $("#" + rowid).remove();
        }

        function validateWidth() {
            var totalWidth = 0;
            jQuery.each($('#reportColumnsTable > tbody > tr'), function () {
                var tr = $(this);

                if (tr.attr("id") != "floating-row") {
                    totalWidth += Number(tr.find("td[class=col_width] > input").val());
                }
            });

            return totalWidth <= 100;
        }

        var column_counter = 0;
        function getDefaultReportColumnHtml() {
            var rowID = 'row_' + (++column_counter);

            var colHtml = '<tr id="' + rowID + '" style="">';
            colHtml += '    <td class="col_name" style="width:200px;border:1px solid black;" ><div ' + (model.Exists ? "" : "contenteditable") + ' ></div></td>';
            colHtml += '    <td class="col_type" style="width:200px;border:1px solid black;"><select style="width:100%;"><option value="string">String</option><option value="number">Numeric</option><option value="SPPage">SPPage</option><option value="user">User</option> </select></td>';
            colHtml += '    <td class="col_help" style="width:300px;border:1px solid black;"><div ' + (model.Exists ? "" : "contenteditable") + '></div></td>';
            colHtml += '    <td class="col_width" style="width:100px;border:1px solid black;" ><input type="text" style="width:100%; text-align:center;" /></td>';
            colHtml += '    <td style="text-align:left; padding-left:10px;">' + (model.Exists ? "" : '<a style="color: Black" href="' + "javascript:onRemoveReportColumn('" + rowID + "')" + '"><%=CardioLog.API.Localization.getText("$Remove$")%></a>') + '</td>';
            colHtml += '</tr>';

            return colHtml
        }



        function getRuleValueCtrl(value) {
            var html = '';
            var ruleField = $("#ruleField").val();

            if (ruleField == "entityType") {

                html = '<select style="width:200px">';
                for (var i = 1; i < 14; i++) {
                    if (value === i.toString()) {
                        html += '<option selected="selected" value="' + i + '">' + i + '</option>';
                    }
                    else {
                        html += '<option value="' + i + '">' + i + '</option>';
                    }
                }

                html += '</select>';
            }
            else if (ruleField == "aggregated") {
                return '<select style="width:200px">' +
                                '<option ' + ((value === "1") ? 'selected="selected"' : '') + 'value="1"><%=CardioLog.API.Localization.getText("$True$")%></option>' +
                                '<option ' + ((!value || value === "0") ? 'selected="selected"' : '') + ' value="0"><%=CardioLog.API.Localization.getText("$False$")%></option>' +
                    '</select>';
            }
            else {
                html = '<input type="text" value="' + (value ? value : '') + '"style="width:100%"/>';
            }

            return html;
        }

        var rule_counter = 0;
        function getDefaultChartRuleHtml() {
            var rowID = 'row_' + (++rule_counter);

            var colHtml = '<tr id="' + rowID + '" style="">';
            colHtml += '    <td class="rule_name" style="width:200px;border:1px solid black;" ><div ' + (model.Exists ? "" : "contenteditable") + '></div></td>';
            colHtml += '    <td class="rule_value" style="width:200px;border:1px solid black;" >' + getRuleValueCtrl(null) + '</td>';
            colHtml += '    <td style="text-align:left; padding-left:20px;">' + (model.Exists ? "" : '<a href="' + "javascript:onRemoveChartRule('" + rowID + "')" + '"><%=CardioLog.API.Localization.getText("$Remove$")%></a>') + '</td>';
            colHtml += '</tr>';

            return colHtml
        }

        function getCategory() {
            return model.Location.Category;
        }

        function buildProcedureName() {
            return ("stp_" + getCategory().replace(/ /g, "_") + "_" + $("#ctrlName").val().replace(/ /g, "_") + "_" + $("#ctrlType").val()).toLowerCase();
        }
        function syncViewToModel() {
            model.Type = $("#ctrlType").val();
            model.Name = $("#ctrlName").val();
            model.Description = $("#ctrlDescription").val();

//            model.Location = {
//                DirectoryId: $("#hdnLocation").val(),
//                DirectoryPath: $("#locationPath").val(),
//                Order: $("#hdnLocationOrder").val(),
//                Category: $("#hdnLocationCategory").val()
//            };

            model.Prefs = $("#control-prefs").val(); //.replace("_INTERNAL_REPORT_NAME", model.Name);
            model.DataBinding.Procedure = $("#txtProc").val();

            //if (model.Exists) {
                model.DataBinding.ProcedureBody = $("#txtProcBody").val();
            //}


            if (model.Type == "Chart") {
                model.ChartField = $("#ruleField").val();
            }

            model.DataBinding.Columns = [];

            if (model.Type == "Table") {
                jQuery.each($('#reportColumnsTable > tbody > tr'), function () {
                    var tr = $(this);
                    if (tr.attr("id") != "floating-row") {
                        //<column id="url" title="Url" width="0" type="hidden" />
                        var col = createReportColumn(tr);
                        model.DataBinding.Columns.push(col);

                        if (col.Type == "SPPage") {
                            col = {};
                            col["ID"] = "url";
                            col["Name"] = "Url";
                            col["Type"] = "hidden";
                            col["Width"] = 0;
                            col["Description"] = "";

                            model.DataBinding.Columns.push(col);
                        }

                        if (col.Type == "user") {
                            col = {};
                            col["ID"] = "userAccountName";
                            col["Name"] = "userAccountName";
                            col["Type"] = "hidden";
                            col["Width"] = 0;
                            col["Description"] = "";

                            model.DataBinding.Columns.push(col);
                        }
                    }
                });
            }

            model.DataBinding.Rules = [];
            if (model.Type == "Chart") {
                jQuery.each($('#chartRulesTable > tbody > tr'), function () {
                    var tr = $(this);
                    if (tr.attr("id") != "rules-floating-row") {
                        //<column id="url" title="Url" width="0" type="hidden" />
                        var rule = createChartRule(tr);
                        model.DataBinding.Rules.push(rule);
                    }
                });
            }
        }

        function createChartRule(row) {
            var rule = {};
            jQuery.each($('#' + row.attr("id") + ' > td'), function () {
                switch ($(this).attr("class")) {
                    case "rule_name":
                        rule["Name"] = $(this).text();
                        rule["ID"] = 0;

                        break;

                    case "rule_value":
                        switch ($("#ruleField").val()) {
                            case "entityType":
                            case "aggregated":
                                rule["Value"] = $(this).find("select option:selected").val();
                                break;

                            default:
                                rule["Value"] = $(this).find("input").val();
                                break;
                        }

                        break;
                }
            });

            return rule;

        }

        function createReportColumn(row) {
            var col = {};
            jQuery.each($('#' + row.attr("id") + ' > td'), function () {
                switch ($(this).attr("class")) {
                    case "col_name":
                        col["Name"] = $(this).text();
                        col["ID"] = col["Name"].replace(/ /g, "");
                        break;

                    case "col_help":
                        col["Description"] = $(this).text();
                        break;

                    case "col_type":
                        col["Type"] = $(this).find("select option:selected").val();
                        break;

                    case "col_width":
                        col["Width"] = $(this).find("input").val();
                        break;
                }
            });

            return col;
        }

        var selectedDir = {};

        function onDirChanged() {

            var entry = $(event.srcElement);
            selectedDir["id"] = entry.val();
            selectedDir["order"] = entry.attr("order");

            if (!model.Exists && $("#ctrlName").val()) {
                $("#txtProc").val(buildProcedureName());
            }

            return true;
        }

        function loadChartRules() {
            $("#ruleField").val(model.ChartField);

            rule_counter = 0;
            for (var i = 0; i < model.DataBinding.Rules.length; i++) {
                var rule = model.DataBinding.Rules[i];
                $("#chartRulesTable > tbody > tr:last").before(loadChartRule(rule));
            }
        }

        function loadChartRule(rule) {
            var rowID = 'row_' + (++rule_counter);

            var ruleHtml = '<tr id="' + rowID + '" style="">';
            ruleHtml += '    <td class="rule_name" style="width:100px;border:1px solid black;" ><div ' + (model.Exists ? "" : "contenteditable") + '>' + rule.Name + '</div></td>';
            ruleHtml += '    <td class="rule_value" style="width:200px;border:1px solid black;" >' + getRuleValueCtrl(rule.Value) + '</td>';
            ruleHtml += '    <td style="text-align:left; padding-left:20px;">' + (model.Exists ? "" : '<a href="' + "javascript:onRemoveChartRule('" + rowID + "')" + '"><%=CardioLog.API.Localization.getText("$Remove$")%></a>') + '</td>';
            ruleHtml += '</tr>';

            return ruleHtml;
        }

        function loadReportColumns() {
            column_counter = 0;
            for (var i = 0; i < model.DataBinding.Columns.length; i++) {
                var col = model.DataBinding.Columns[i];
                if (col["Type"] != "hidden") {
                    $("#reportColumnsTable > tbody > tr:last").before(loadReportColumn(col));
                }
            }
        }


        function getSelected(colVal, val) {
            return colVal === val ? 'selected' : '';
        }

        
        function loadReportColumn(col) {
            var rowID = 'row_' + (++column_counter);

            var colHtml = '<tr id="' + rowID + '" style="">';
            colHtml += '    <td class="col_name" style="width:200px;border:1px solid black;" ><div ' + (model.Exists ? "" : "contenteditable") + '>' + col.Name + '</div></td>';
            colHtml += '    <td class="col_type" style="width:200px;border:1px solid black;">';
            colHtml += '        <select style="width:100%;">';
            colHtml += '            <option value="string" ' + getSelected(col.Type, 'string') + '>String</option>';
            colHtml += '            <option value="number" ' + getSelected(col.Type, 'number') + '>Numeric</option>';
            colHtml += '            <option value="SPPage" ' + getSelected(col.Type, 'SPPage') + '>SPPage</option>';
            colHtml += '            <option value="user"   ' + getSelected(col.Type, 'user') + '>User</option>';
//            colHtml += '            <option value="combo"  ' + getSelected(col, 'combo') + '>Combo</option>';
            colHtml += '        </select>';
            colHtml += '    </td>';
            colHtml += '    <td class="col_help" style="width:300px;border:1px solid black;" ><div ' + (model.Exists ? "" : "contenteditable") + '>' + col.Description + '</div></td>';
            colHtml += '    <td class="col_width" style="width:100px;border:1px solid black;" ><input type="text" style="width:100%; text-align:center;" value="' + col.Width + '"/></td>';
            colHtml += '    <td style="text-align:left; padding-left:20px;">' + (model.Exists ? "" : '<a href="' + "javascript:onRemoveReportColumn('" + rowID + "')" + '"><%=CardioLog.API.Localization.getText("$Remove$")%></a>') + '</td>';
            colHtml += '</tr>';

            return colHtml;
        }

        function syncModelToView() {
            $("#ctrlName").val(model.Name);
            $("#ctrlType").val(model.Type);
            $("#locationPath").val(model.Location.DirectoryPath);

            if (model.Type != "MenuEntry") {
                $("#procBody").show();
                if (!model.Exists) {
                    $("#divProcBody").hide();
                }
            }
            

            if (model.Exists) {
                $("#deletebutton").show();
                $("#btnAddColumn").hide();
                $("#btnAddRule").hide();

                if (model.Type == "MenuEntry") {
                    onControlTypeChanged();
                }
                else {
                    $("#divProcBody").text(model.DataBinding.ProcedureTitle);
                    $("#txtProcBody").val(model.DataBinding.ProcedureBody);
                    $("#procBody").show();

                    $("#ctrlDescription").val(model.Description);
                    $("#ctrlType").val(model.Type);
                    $("#txtProc").val(model.DataBinding.Procedure);
                    $("#control-prefs").val(model.Prefs);

                    $("#reportColumnsDiv").hide();
                    $("#chartRulesDiv").hide();

//                    $("#reportColumnsDiv").attr("readOnly", "readOnly");
//                    $("#chartRulesDiv").attr("disabled", "disabled");

                    if (model.Type == "Table") {
                        loadReportColumns();
                        $("#reportColumnsDiv").show();
                    }
                    else if (model.Type == "Chart") {
                        loadChartRules();
                        $("#chartRulesDiv").show();
                    }
                    else {
                        $("#chartRulesDiv").hide();
                        $("#reportColumnsDiv").hide();
                    }
                }
            }
            else {
                $("#deletebutton").hide();
                onControlTypeChanged();
            }
        }

        function onCancel() {
            window.location = "index.aspx";
        }

        function onDelete() {
            __doPostBack(null, 'delete');
        }

        function validate() {

            if (model.Type == "Table") {
                if (!validateWidth()) {
                    alert('Your total columns width exceeds 100%. Please change it before saving.');
                    return false;
                }
            }

            if (model.Type != "MenuEntry") {
                if (model.Location.DirectoryId <= 0) {
                    alert('Your cannot save a control on root menu. Please place it under a menu entry.');
                    return false;
                }
            }

            return true;
        }

        function onSave() {
            if (!validate()) {
                return;
            }

            syncViewToModel();

            if (!validateModel(model)) {
                return;
            }
            
            $("#hdnModel").val($.toJSON(model));

            __doPostBack(null, 'save');
        }


       function validateModel(model) {
            if (model.Name.length == 0) {
                alert("Widget Name cannot be empty.");
                return false;
            }

            if (model.Name.length > 150) {
                alert("Widget Name is too long. Please enter value with length of max 150 characters.");
                return false;
            }

            if (model.Description.length > 255) {
                alert("Widget Description is too long. Please enter value with length of max 255 characters.");
                return false;
            }

            if (model.Type == "Table") {
                for (var i =0; i < model.DataBinding.Columns.length; i++) {
                    var col = model.DataBinding.Columns[i];
                    if (col.Name.length == 0 ) {
                        alert("Column name cannot be empty.");
                        return false;
                    }

                    if (col.Name.length > 255 ) {
                        alert("Name " + col.Name + " is too long. Please enter value with length of max 255 characters.");
                        return false;
                    }
                }
            }
            if (model.Type == "Chart") {
                for (var i =0; i < model.DataBinding.Rules.length; i++) {
                    var rule = model.DataBinding.Rules[i];
                    if (rule.Name.length == 0 ) {
                        alert("Rule name cannot be empty.");
                        return false;
                    }

                    if (rule.Name.length > 255) {
                        alert("Name " + rule.Name + " is too long. Please enter value with length of max 255 characters.");
                        return false;
                    }

                    if (rule.Value.length > 255 ) {
                        alert("Value " + rule.Value  + " is too long. Please enter value with length of max 255 characters.");
                        return false;
                    }
                }
            }
            return true;
        }

        function init() {
            if (document.readyState != "complete") {
                window.setTimeout(init, 50);
                return;
            }

            var modelData = $("#hdnModel").val();
            if (modelData && modelData.length > 0) {
                model = $.evalJSON(modelData);

                syncModelToView();

                setCaption(getparam("type"));
            }

            var err = $("#hdnError").val();
            if (err && err.length > 0) {
                alert(err);
            } 
        }

        function setCaption(type) {
            var caption;
            if (model.Exists){
                caption = "Edit " + $("#ctrlName").val() + " " + (type == "MenuEntry" ? "Menu" : type);
            }
            else{
                caption = "New " + (type == "MenuEntry" ? "Menu" : type);
            }

            $("#widjetPropertiesTitle").text(type + " Properties");

            parent.setCaption('Administration', false, caption);
        }


        init();

        showBottomGreyBar();

        $(window).unload(function () {
            showBottomWhiteBar()
        });

        // add help bubbles
        var atags = document.getElementsByTagName("A");
        for (var i = 0; i < atags.length; i++) {
            var _a = atags[i];
            if (_a.className.indexOf('qmark') > -1) {
                _a.data = qmarkData[_a.id];
                _a.onmouseover = function () {
                    window.top.document.openQBubble(window, null, this, this.data, 420);
                };
            }
        }

        

    </script>
</head>
<body style="width: 100%; height: 100%; overflow: hidden;">
    <form id="form1" runat="server" method="post" action="#" class="frmbox">
    <asp:ScriptManager ID="smgr" runat="server">
    </asp:ScriptManager>
    <asp:HiddenField ID="hdnProcBody" runat="server" />
    <asp:HiddenField ID="hdnProcBodyConst" runat="server" />
    <asp:HiddenField ID="hdnError" runat="server" />
    <asp:HiddenField ID="hdnModel" runat="server" />
    <asp:HiddenField ID="hdnReportDirectories" runat="server" />
    <div class="loader" id="loader" style="display: none; top: 40%; left: 40%; position: absolute;">
        <img alt="loading..." src="../images/ConfigWizard/ajax-loader.gif" />
    </div>
    <div id="overlay">
    </div>
    <div class="wrapper" style="margin: 0px;">
        <div class="section">
            <div class="content">
                <!--innerbox -->
                <div class="innerbox">
                    <!--innertop -->
                    <div class="innerboxtop">
                        <div class="tl">
                            <div class="tr">
                                <h2 id="settingsLable" runat="server">
                                    <%=CardioLog.API.Localization.getText("$General Settings$")%> </h2>
                            </div>
                        </div>
                    </div>
                    <div class="innersection">
                        <div class="formbox">
                            <table style="width: 800px; margin-left: 3px;">
                                <tr>
                                    <td style="width: 150px;">
                                        <label>
                                            <%=CardioLog.API.Localization.getText("$Type$")%>:</label>
                                    </td>
                                    <td>
                                        <select id="ctrlType" style="width: 60%;" disabled="disabled">
                                            <option value="MenuEntry"><%=CardioLog.API.Localization.getText("$Menu$")%></option>
                                            <option value="Table"><%=CardioLog.API.Localization.getText("$Table$")%></option>
                                            <option value="Meter"><%=CardioLog.API.Localization.getText("$Meter$")%></option>
                                            <option value="Chart"><%=CardioLog.API.Localization.getText("$Chart$")%></option>
                                        </select>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <label>
                                            <%=CardioLog.API.Localization.getText("$Title$")%>:</label>
                                    </td>
                                    <td>
                                        <input id="ctrlName" type="text" style="width: 60%;" />
                                    </td>
                                </tr>
                                <tr id="rowDescription">
                                    <td style="vertical-align: top;">
                                        <label>
                                            <%=CardioLog.API.Localization.getText("$Description$")%>:</label>
                                    </td>
                                    <td>
                                        <textarea id="ctrlDescription" cols="2" rows="2" style="width: 60%; height: 70px;"></textarea>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="vertical-align: top;">
                                        <label>
                                            <%=CardioLog.API.Localization.getText("$Location$")%>:</label>
                                    </td>
                                    <td>
                                        <div id="locationAlterDiv">
                                            <%--<asp:HiddenField ID="hdnLocation" runat="server" />
                                            <asp:HiddenField ID="hdnLocationCategory" runat="server" />
                                            <asp:HiddenField ID="hdnLocationOrder" runat="server" />--%>
                                            <input id="locationPath" type="text" style="width: 60%;" readonly="readonly" />
                                            <input id="locationBtn" type="button" style="width: 15%;" value="Browse" onclick="onBrowse()" />
                                        </div>
                                    </td>
                                </tr>
                                <tr id="rowPrefs" style="display: none;">
                                    <td style="vertical-align: top;">
                                        <label>
                                            <%=CardioLog.API.Localization.getText("$Prefs$")%>:</label>
                                    </td>
                                    <td>
                                        <textarea id="control-prefs" cols="2" rows="2" style="width: 100%; height: 70px;"></textarea>
                                    </td>
                                </tr>
                            </table>
                            <br />
                            <br />
                            <asp:HiddenField ID="hdnVersion" runat="server" />
                        </div>
                    </div>
                    <!--innerbottom -->
                    <div class="innerboxbot">
                        <div class="bl">
                            <div class="br">
                            </div>
                        </div>
                    </div>
                </div>
                
                <div id="widjetPropertiesSection" class="innerbox">
                    <!--innertop -->
                    <div class="innerboxtop">
                        <div class="tl">
                            <div class="tr">
                                <h2 id="widjetPropertiesTitle" runat="server">
                                    <%=CardioLog.API.Localization.getText("$Properties$")%></h2>
                            </div>
                        </div>
                    </div>
                    <div class="innersection">
                        <div class="formbox">
                            <div id="reportColumnsDiv" style="display: none;">
                                <table id="reportColumnsHeaders" style="width: 830px; border-collapse: collapse;
                                    table-layout: fixed; text-align: center; font-weight: bold;">
                                    <tr>
                                        <td style="width: 200px; border: 1px solid black; background-color: Gray;">
                                            <%=CardioLog.API.Localization.getText("$Title$")%>
                                        </td>
                                        <td style="width: 200px; border: 1px solid black; background-color: Gray;">
                                            <%=CardioLog.API.Localization.getText("$Type$")%>
                                        </td>
                                        <td style="width: 300px; border: 1px solid black; background-color: Gray;">
                                            <%=CardioLog.API.Localization.getText("$Description$")%>
                                        </td>
                                        <td style="width: 100px; border: 1px solid black; background-color: Gray;">
                                            <%=CardioLog.API.Localization.getText("$Width$")%> (%)
                                        </td>
                                        <td>
                                        </td>
                                    </tr>
                                </table>
                                <table id="reportColumnsTable" style="width: 870px; table-layout: fixed; border-collapse: collapse;
                                    text-align: center;">
                                    <tr id="floating-row">
                                        <td style="width: 200px;">
                                        </td>
                                        <td style="width: 200px;">
                                        </td>
                                        <td style="width: 300px;">
                                        </td>
                                        <td style="width: 100px;">
                                        </td>
                                        <td style="text-align: left; padding-left: 20px;">
                                            <a id="btnAddColumn" style="color: Black" href="javascript:onAddReportColumn()"><%=CardioLog.API.Localization.getText("$Add$")%></a>
                                        </td>
                                    </tr>
                                </table>
                            </div>
                            <div id="chartRulesDiv" style="display: none;">
                                <table style="display:none;">
                                    <tr>
                                        <td style="width: 120px;">
                                            <%=CardioLog.API.Localization.getText("$Vertical Field$")%>:
                                        </td>
                                        <td>
                                            <select id="ruleField" onchange="onRuleFieldChanged()">
                                                <option value="ruleType">Rule Type</option>
                                            </select>
                                        </td>
                                    </tr>
                                </table>
                                <div style="height: 10px;">
                                </div>
                                <h3>
                                    Chart Series:</h3>
                                <div style="height: 5px;">
                                </div>        
                                <table id="chartRulesHeaders" style="width: 670px; border-collapse: collapse; text-align: center;
                                    font-weight: bold;">
                                    <tr>
                                        <td style="width: 200px; border: 1px solid black; background-color: Gray;">
                                            <%=CardioLog.API.Localization.getText("$Title$")%>
                                        </td>
                                        <td style="width: 200px; border: 1px solid black; background-color: Gray;">
                                            <%=CardioLog.API.Localization.getText("$Value$")%>
                                        </td>
                                        <td>
                                        </td>
                                    </tr>
                                </table>
                                <table id="chartRulesTable" style="width: 670px; border-collapse: collapse; text-align: center;">
                                    <tr id="rules-floating-row">
                                        <td style="width: 200px;">
                                        </td>
                                        <td style="width: 200px;">
                                        </td>
                                        <td style="text-align: left; padding-left: 20px;">
                                            <a id="btnAddRule" href="javascript:onAddRule()"><%=CardioLog.API.Localization.getText("$Add$")%></a>
                                        </td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>
                
                    <!--innerbottom -->
                    <div class="innerboxbot">
                        <div class="bl">
                            <div class="br">
                            </div>
                        </div>
                    </div>
                </div>
            
                <div id="divDataBinding"  class="innerbox">
                    <!--innertop -->
                    <div class="innerboxtop">
                        <div class="tl">
                            <div class="tr">
                                <h2 id="H1" runat="server">
                                    <%=CardioLog.API.Localization.getText("$Data$")%></h2>
                            </div>
                        </div>
                    </div>
                    <div class="innersection">
                        <div class="formbox">
                            <div style="margin-left: 3px;">
                                <table style="width: 800px">
                                    <tr>
                                        <td style="width: 150px; " >
                                            <label>
                                                <%=CardioLog.API.Localization.getText("$Procedure Name$")%>:</label>
                                        </td>
                                        <td>
                                            <input id="txtProc" type="text" style="width: 60%;" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <td style="height:20px;" colspan="2">
                                        </td>
                                    </tr>
                                    <tr id="procBody" style="display:none;">
                                        <td style="width: 150px; vertical-align: top;">
                                            <label><%=CardioLog.API.Localization.getText("$Procedure Body$")%>:</label>
                                        </td>
                                        <td style="height:150px; font-family:Calibri" >
                                            <div id="divProcBody" style="width: 80%; height: 120px; " >
                                            </div>
                                            <textarea id="txtProcBody" cols="2" rows="2" style="width: 100%; height: 145px;"></textarea>        
                                        </td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>
                    <!--innerbottom -->
                    <div class="innerboxbot">
                        <div class="bl">
                            <div class="br">
                            </div>
                        </div>
                    </div>
                </div>            
            </div>
        </div>
        <div class="bigboxbot homepagebot">
            <div class="bl">
                <div class="br">
                    <!--footer -->
                    <div class="footer">
                        <div class="alignleft">
                            <a id="backLink" runat="server" href="index.aspx" class="bluelink"><< <%=CardioLog.API.Localization.getText("$Back to dashboard$")%></a>
                        </div>
                        <div class="alignright">
                            <ul class="btns">
                                <li id="deletebutton" runat="server" ><a href="javascript:onDelete();"
                                    class="btn btn-brown">
                                    <%=CardioLog.API.Localization.getText("$Delete$")%></a></li>
                                <li><a id="savebutton" runat="server" href="javascript:onSave();" class="btn btn-darkblue">
                                    <%=CardioLog.API.Localization.getText("$Save$")%> </a></li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </form>
</body>
</html>
